﻿'Option Strict On
Imports System.IO
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.Threading
Module Module1
    Public Const NoTrial As Integer = 10   ' 試行回数
    Public Const MaxNoClass As Integer = 5      ' 最大クラス数
    Public NoClass As Integer                   ' エントリークラス数
    Public Const NoGroup As Integer = 5    ' グループ数
    Public Const NoStep As Integer = 5      ' ステップ数
    Public Const MaxStep As Integer = 5       ' 入力ステップの最大値
    Public PauseTime() As Integer = {3, 6, 10}     ' チャットを行うタイミング
    Public TrialCounter(MaxNoClass - 1) As Integer     ' 試行回数のカウンター
    Public StepData(MaxNoClass - 1, NoGroup - 1, NoTrial - 1, 2) As Integer _
        '  StepData(i,j,k,0):入力ステップ StepData(i,j,k,1):進度 StepData(i,j,k,2):累積進度
    '      i:クラス番号 j:グループ番号A=0,B=1...，k:試行回数
    Public SvSessionList(MaxNoClass - 1, NoGroup - 1) As SvSessionClass
    Public ClassStatus(MaxNoClass - 1) As Integer     ' 各クラスのStatus 0:実験終了 1:Entry完了 2:実験中  3:チャット中
    ' チャットログ記録
    Public ChatLog1 As ArrayList = New ArrayList()
    Public ChatLog2 As ArrayList = New ArrayList()
    Public ChatLog3 As ArrayList = New ArrayList()
    Public ChatLog4 As ArrayList = New ArrayList()
    Public ChatLog5 As ArrayList = New ArrayList()
    Public ExEndFlag(MaxNoClass - 1) As Boolean   ' 実験終了フラグ
    Public Const Splitter As String = vbTab   ' 区切り文字
    Public SysLog As ArrayList = New ArrayList()      ' System Log

    ' 代表者会議用デリゲート
    Delegate Sub RTBDelegate(ByVal i As Integer, ByVal j As String, ByVal s As String)
    ' ボタン設定用デリゲート
    Delegate Sub btnDelegate(ByVal btnObj As Button, ByVal OnOff As Boolean)
    ' メッセージボックス用デリゲート
    Delegate Function MsgDelegate(ByVal owner As IWin32Window, ByVal s As String, ByVal cptn As String, _
                                  ByVal btn As MessageBoxButtons, ByVal icn As MessageBoxIcon)
    ' データグリッドビュー用デリゲート
    Delegate Sub iDGVDelegate(ByVal m As Integer, ByVal iRow As Integer, ByVal jColumn As Integer, ByVal i As Integer)
    Delegate Sub sDGVDelegate(ByVal m As Integer, ByVal iRow As Integer, ByVal jColumn As Integer, ByVal s As String)
End Module
Public Class Form1

    Dim DGV() As DataGridView
    Dim RTBX() As RichTextBox
    Dim btnExStrt() As Button
    Dim btnExEnd() As Button
    Dim btnChtStart() As Button
    Dim btnChtEnd() As Button
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'Control.CheckForIllegalCrossThreadCalls = False
        Dim SvThread As Thread
        Dim i, j, k, l As Integer

        ' TrialCounterとStepData の初期化
        For i = 0 To TrialCounter.GetUpperBound(0)
            TrialCounter(i) = 0
            ExEndFlag(i) = False
            ClassStatus(i) = 0
        Next
        NoClass = 0
        For i = 0 To StepData.GetUpperBound(0)
            For j = 0 To StepData.GetUpperBound(1)
                For k = 0 To StepData.GetUpperBound(2)
                    For l = 0 To StepData.GetUpperBound(3)
                        StepData(i, j, k, l) = 0
                    Next
                Next
            Next
        Next

        ' フォームの初期化
        Initialize_Form()
        ' 通信用スレッドの開始
        SvThread = New Thread(AddressOf SvSessionThread)
        SvThread.IsBackground = True
        SvThread.Start()
    End Sub
    ' Delegate用プログラム
    ' RitchTextBoxに書き込む
    Public Sub Set_RTB(ByVal ClassNO As Integer, ByVal GroupNo As String, ByVal s As String)
        RTBX(ClassNO - 1).AppendText(ClassNO & "-" & GroupNo & ">" & s & vbCrLf)
    End Sub
    ' ボタンの設定
    Public Sub Set_Btn(ByVal btn As Button, ByVal OnOff As Boolean)
        btn.Enabled = OnOff
    End Sub
    ' データグリッドビュー用デリゲート
    Public Sub Set_iDGV(ByVal m As Integer, ByVal jColumn As Integer, ByVal iRow As Integer, ByVal i As Integer)
        DGV(m).Item(jColumn, iRow).Value = i
    End Sub
    Public Sub Set_sDGV(ByVal m As Integer, ByVal jColumn As Integer, ByVal iRow As Integer, ByVal s As String)
        DGV(m).Item(jColumn, iRow).Value = s
    End Sub
    ' フォームの初期化
    Private Sub Initialize_Form()
        Dim i, j, k As Integer
        DGV = New DataGridView() {DataGridView1, DataGridView2, DataGridView3, DataGridView4, DataGridView5}
        RTBX = New RichTextBox() {RichTextBox1, RichTextBox2, RichTextBox3, RichTextBox4, RichTextBox5}
        btnExStrt = New Button() {btnExStart0, btnExStart1, btnExStart2, btnExStart3, btnExStart4, btnExStart5}
        btnExEnd = New Button() {btnExEnd0, btnExEnd1, btnExEnd2, btnExEnd3, btnExEnd4, btnExEnd5}
        btnChtStart = New Button() {btnChtStart0, btnChtStart1, btnChtStart2, btnChtStart3, btnChtStart4, btnChtStart5}
        btnChtEnd = New Button() {btnChtEnd0, btnChtEnd1, btnChtEnd2, btnChtEnd3, btnChtEnd4, btnChtEnd5}
        ' DataGridViewの設定
        For i = 0 To MaxNoClass - 1
            TabControl1.TabPages.Item(i).Visible = True
            DGV(i).Enabled = True
            DGV(i).ColumnCount = NoGroup
            DGV(i).RowCount = NoTrial * 3 + 1
            DGV(i).AutoSize = False
            k = Strings.Asc("A")
            For j = k To Strings.Asc("E")
                DGV(i).Columns(j - k).Frozen = False
                DGV(i).Columns(j - k).HeaderText = Strings.Chr(j)
                DGV(i).AutoResizeColumn(j - k)
            Next
            DGV(i).ScrollBars = ScrollBars.Both
            DGV(i).AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells
            DGV(i).Rows(0).HeaderCell.Value = "Status"
            For j = 1 To NoTrial
                DGV(i).Rows(j * 3 - 2).Frozen = False
                DGV(i).Rows(j * 3 - 1).Frozen = False
                DGV(i).Rows(j * 3).Frozen = False
                DGV(i).Rows(j * 3 - 2).HeaderCell.Value = "第" & j & "回入力ステップ"
                DGV(i).Rows(j * 3 - 1).HeaderCell.Value = "          進度"
                DGV(i).Rows(j * 3).HeaderCell.Value = "          累積進度"
            Next
            DGV(i).AutoResizeRowHeadersWidth(DataGridViewRowHeadersWidthSizeMode.AutoSizeToAllHeaders)
        Next
        ' イベントハンドラの設定
        For i = 0 To MaxNoClass
            AddHandler btnExStrt(i).Click, AddressOf btnExStart_Click
            AddHandler btnExEnd(i).Click, AddressOf btnExEnd_Click
            AddHandler btnChtStart(i).Click, AddressOf btnChtStart_Click
            AddHandler btnChtEnd(i).Click, AddressOf btnChtEnd_Click
        Next
    End Sub
    ' 通信用スレッド
    Sub SvSessionThread()
        Dim SvListenSocket As Socket
        Dim SvSocket As Socket
        Dim SvAddress As IPAddress
        Dim SvPort As Integer
        Dim SvEndPoint As EndPoint
        Dim SvSession As SvSessionClass

        Try
            ' ソケット作成
            SvListenSocket = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
            SvAddress = IPAddress.Any
            SvPort = 55555
            SvEndPoint = New IPEndPoint(SvAddress, SvPort)
            SvListenSocket.Bind(SvEndPoint)
            ' リッスン
            SvListenSocket.Listen(10)
            Do
                ' 接続待ち
                SvSocket = SvListenSocket.Accept
                ' SvSessionClassの作成
                SvSession = New SvSessionClass(SvSocket, Me)
                ' 通信用スレッドを開始
                SvSession.SvStartThread()
            Loop
        Catch ex As Exception
            MessageBox.Show(Me, ex.Message, "通信用スレッドエラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ' 各クラスのStatusをセット
    Private Sub Set_ClassStatus(ByVal clsno As Integer, ByVal stts As Integer)
        SyncLock ClassStatus.SyncRoot
            If clsno > 0 Then
                ClassStatus(clsno - 1) = stts
            Else
                For i As Integer = 0 To ClassStatus.GetUpperBound(0)
                    If ClassStatus(i) > 0 Then
                        ClassStatus(i) = stts
                    End If
                Next
            End If
        End SyncLock
    End Sub
    ' 実験開始
    Private Sub btnExStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim chkRslt(MaxNoClass) As Integer
        Dim i As Integer
        ' クラスのグループが揃っているかどうかチェック
        If sender.tag > 0 Then
            If ClassStatus(sender.tag - 1) = 1 Then
                ' 実験開始コマンド送信
                Send_AllGroups(sender.tag, "EXSTART")
                Set_ClassStatus(sender.tag, 2)  ' Set status 
            Else
                Me.Invoke(New MsgDelegate(AddressOf MessageBox.Show), New Object() {Me, "クラス" & sender.tag & "のエントリーは完了していません。まだ，実験を始められません。", _
                        "エントリー未完了通知", MessageBoxButtons.OK, MessageBoxIcon.Information})
            End If
        Else
            For i = 0 To ClassStatus.GetUpperBound(0)
                If ClassStatus(i) = 1 Then
                    ' 実験開始コマンド送信
                    Send_AllGroups(i + 1, "EXSTART")
                    Set_ClassStatus(i + 1, 2)
                End If
            Next
        End If
    End Sub
    ' 実験終了
    Private Sub btnExEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim i As Integer
        If sender.tag > 0 Then
            If ClassStatus(sender.tag - 1) > 0 Then
                ' 実験終了コマンド送信
                Send_AllGroups(sender.tag, "EXEND")
                Set_ClassStatus(sender.tag, 0)
            End If
        Else
            For i = 0 To ClassStatus.GetUpperBound(0)
                If ClassStatus(i) > 0 Then
                    ' 実験終了コマンド送信
                    Send_AllGroups(i + 1, "EXEND")
                    Set_ClassStatus(i + 1, 0)
                End If
            Next
        End If
    End Sub
    ' チャット開始
    Private Sub btnChtStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim i As Integer
        If sender.tag > 0 Then
            If ClassStatus(sender.tag - 1) > 0 AndAlso ClassStatus(sender.tag - 1) < 3 Then
                ' チャット開始コマンド送信
                Send_AllGroups(sender.tag, "CHTSTART")
                Set_ClassStatus(sender.tag, 3)
            End If
        Else
            For i = 0 To ClassStatus.GetUpperBound(0)
                If ClassStatus(i) > 0 AndAlso ClassStatus(i) < 3 Then
                    ' チャット開始コマンド送信
                    Send_AllGroups(i + 1, "CHTSTART")
                    Set_ClassStatus(i + 1, 3)
                End If
            Next
        End If

    End Sub
    ' チャット終了
    Private Sub btnChtEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim i As Integer
        If sender.tag > 0 Then
            If ClassStatus(sender.tag - 1) = 3 Then
                ' チャット終了コマンド送信
                Send_AllGroups(sender.tag, "CHTEND")
                Set_ClassStatus(sender.tag, 2)
            End If
        Else
            For i = 0 To ClassStatus.GetUpperBound(0)
                If ClassStatus(i) = 3 Then
                    ' チャット終了コマンド送信
                    Send_AllGroups(i + 1, "CHTEND")
                    Set_ClassStatus(i + 1, 2)
                End If
            Next
        End If
    End Sub
    ' チャットログの出力
    Private Sub Output_Log()
        Dim i As Integer
        Dim fName As String

        For i = 0 To MaxNoClass - 1
            fName = Gen_FileName("C", i + 1)
            If TrialCounter(i) > 0 Then
                Select Case i
                    Case 0
                        Save_ArrayList(fName, ChatLog1)
                    Case 1
                        Save_ArrayList(fName, ChatLog2)
                    Case 2
                        Save_ArrayList(fName, ChatLog3)
                    Case 3
                        Save_ArrayList(fName, ChatLog4)
                    Case 4
                        Save_ArrayList(fName, ChatLog5)
                End Select
            End If
        Next
    End Sub
    ' チャットログをファイルに出力
    Private Sub Save_ArrayList(ByVal fname As String, ByVal chatLog As ArrayList)
        Dim i As Integer
        Dim fs As FileStream = New FileStream(fname, FileMode.Create)
        Dim sw As StreamWriter = New StreamWriter(fs, Encoding.GetEncoding("shift_jis"))
        sw.WriteLine(",クラス,グループ,メッセージ")
        With chatLog
            For i = 0 To .Count - 1
                sw.WriteLine(.Item(i).ToString)
            Next
        End With
        sw.Close()
    End Sub
    ' 結果ファイルの出力
    Private Sub Output_Result()
        Dim i As Integer
        Dim fName As String

        For i = 0 To MaxNoClass - 1
            If TrialCounter(i) > 0 Then
                fName = Gen_FileName("S", i + 1)
                Save_DataGridView(i + 1, fName)
            End If
        Next
    End Sub
    ' DataGridViewをファイルにする
    Private Sub Save_DataGridView(ByVal clno As Integer, ByVal fName As String)
        Dim i, j, k As Integer
        Dim wrk() As String = {"入力ステップ,", "進度,", "累積進度,"}
        Dim s As String
        Dim fs As FileStream = New FileStream(fName, FileMode.Create)
        Dim sw As StreamWriter = New StreamWriter(fs, Encoding.GetEncoding("shift_jis"))
        Try
            sw.WriteLine(",グループA,グループB,グループC,グループD,グループE")
            With DGV(clno - 1)
                For i = 1 To .Rows.Count - 1 Step 3
                    For k = 0 To 2
                        If k = 0 Then
                            s = "第" & i \ 3 + 1 & "回"
                        Else
                            s = "      "
                        End If
                        s &= wrk(k)
                        For j = 0 To .Columns.Count - 1
                            If .Rows(i + k).Cells(j).Value <> Nothing Then
                                s &= .Rows(i + k).Cells(j).Value.ToString
                            Else
                                s &= "0"
                            End If
                            If j < .Columns.Count - 1 Then
                                s &= ","
                            End If
                        Next
                        sw.WriteLine(s)
                    Next
                Next
            End With
        Catch ex As Exception
            Me.Invoke(New MsgDelegate(AddressOf MessageBox.Show), New Object() {Me, ex.Message, "結果ファイル出力エラー", MessageBoxButtons.OK, MessageBoxIcon.Error})
        End Try
        sw.Close()
    End Sub
    ' ファイル名を生成
    Private Function Gen_FileName(ByVal t As String, ByVal clno As Integer) As String
        Dim NowDate As Date = Date.Now
        Dim s As String
        s = t & clno & "-" & String.Format("{0:0000}{1:00}{2:00}{3:00}{4:00}{5:00}", NowDate.Year, _
                                                   NowDate.Month, NowDate.Day, NowDate.Hour, NowDate.Minute, _
                                                    NowDate.Second) & ".csv"
        Gen_FileName = s
    End Function
    ' Syslog File 出力
    Private Sub Output_Syslog()
        Dim fName As String
        fName = Gen_FileName("SysLog", 99)
        Dim fs As FileStream = New FileStream(fName, FileMode.Create)
        Dim sw As StreamWriter = New StreamWriter(fs, Encoding.GetEncoding("shift_jis"))
        With SysLog
            For i = 0 To .Count - 1
                sw.WriteLine(.Item(i).ToString)
            Next
            sw.Close()
        End With
    End Sub
    ' 指定されたクラスの全グループにメッセージを送信
    Sub Send_AllGroups(ByVal clno As Integer, ByVal msgString As String)
        Dim i As Integer
        SyncLock SvSessionList.SyncRoot
            For i = 0 To NoGroup - 1
                If SvSessionList(clno - 1, i) IsNot Nothing Then
                    SvSessionList(clno - 1, i).SvWriteLine(msgString)
                End If
            Next
        End SyncLock
    End Sub
    ' 終了ボタン
    Private Sub btnEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnd.Click
        ' 結果ファイル出力
        Output_Result()
        ' チャットログ出力
        Output_Log()
        ' Syslog 出力
        Output_Syslog()
        Me.Close()
    End Sub
End Class
Class SvSessionClass
    'Shared SvSessionList(MaxNoClass - 1, NoGroup - 1) As SvSessionClass
    Dim ClSocket As Socket
    Dim ClStream As NetworkStream
    Dim ClReader As StreamReader
    Public ClWriter As StreamWriter
    Dim ClWriteQueue As Queue
    Dim ClWriteSignal As AutoResetEvent
    Dim ClWriteLoopFlag As Boolean

    Dim clClass As Integer
    Dim clGroup As String
    Dim clGrpNo As Integer
    Dim MainForm As Form1

    Sub New(ByVal SvSocket As Socket, ByVal Mform As Form1)
        MainForm = Mform
        ClSocket = SvSocket
        ClStream = New NetworkStream(ClSocket)
        ClReader = New StreamReader(ClStream, Encoding.UTF8)
        ClWriter = New StreamWriter(ClStream, Encoding.UTF8)
        ClWriter.AutoFlush = True
        ClWriter.NewLine = vbNewLine

        ClWriteQueue = New Queue()
        ClWriteSignal = New AutoResetEvent(False)
        ClWriteLoopFlag = True
    End Sub
    ' 通信開始
    Sub SvStartThread()
        ' 受信処理用スレッドの開始
        Dim ReceiveThread As Thread
        ReceiveThread = New Thread(AddressOf SvReceiveThread)
        ReceiveThread.IsBackground = True
        ReceiveThread.Start()

        ' 送信処理用スレッドの開始
        Dim SendThread As Thread
        SendThread = New Thread(AddressOf SvSendThread)
        SendThread.IsBackground = True
        SendThread.Start()
    End Sub
    ' 受信処理用スレッド
    Sub SvReceiveThread()
        Dim ReceiveData As String

        Try
            Do
                ' データ受信
                ReceiveData = ClReader.ReadLine()
                ' データの有無
                If IsNothing(ReceiveData) Then
                    ' データが無い クライアントのシャットダウン 
                    Process_Shutdown()
                    Exit Do
                End If
                ' 受信データのコマンド処理
                Process_Command(ReceiveData)
            Loop
        Catch ex As Exception
            If clClass > 0 AndAlso ClassStatus(clClass - 1) > 0 Then
                MainForm.Invoke(New MsgDelegate(AddressOf MessageBox.Show), New Object() {MainForm, ex.Message, "受信スレッドエラー", MessageBoxButtons.OK, MessageBoxIcon.Error})
            End If
            Process_Shutdown()
        End Try
    End Sub
    ' 受信データのコマンド処理
    Private Sub Process_Command(ByVal RcvData As String)
        Dim Cmd() As String
        Log_SystemData("Rcv" & clClass & "-" & clGroup & ">" & RcvData)
        Cmd = RcvData.Split(CChar(Splitter))
        Select Case Cmd(0)
            Case "ENTRY"
                Process_Entry(Cmd)
            Case "STEP"
                Process_Step(Cmd)
            Case "MSG"
                Process_MSG(Cmd)
            Case Else
                ' コマンドエラー
                MainForm.Invoke(New MsgDelegate(AddressOf MessageBox.Show), New Object() {MainForm, RcvData, "受信コマンドエラー", MessageBoxButtons.OK, MessageBoxIcon.Error})
        End Select
    End Sub
    ' クライアントがシャットダウン
    Private Sub Process_Shutdown()
        If clClass <> 0 Then
            ' ステータス表示
            MainForm.Invoke(New sDGVDelegate(AddressOf MainForm.Set_sDGV), New Object() {clClass - 1, clGrpNo - 1, 0, "Down"})
            ClSocket.Close()
            SvSessionList(clClass - 1, clGrpNo - 1) = Nothing
        End If
    End Sub
    ' "ENTRY"コマンドの処理
    Private Sub Process_Entry(ByRef cmd() As String)
        Dim i As Integer
        Dim flg As Boolean
        ' クラス番号，グループ名，グループ番号をセット
        ' SvSessionListに登録
        clClass = Integer.Parse(cmd(1))
        clGroup = cmd(2)
        clGrpNo = Asc(cmd(2)) - Asc("A") + 1
        If SvSessionList(clClass - 1, clGrpNo - 1) Is Nothing Then
            MainForm.Invoke(New sDGVDelegate(AddressOf MainForm.Set_sDGV), New Object() {clClass - 1, clGrpNo - 1, 0, "ENTRY"})
            SyncLock SvSessionList.SyncRoot
                SvSessionList(clClass - 1, clGrpNo - 1) = Me
                ' 全グループが登録されたかどうかチェック
                flg = True
                For i = 0 To SvSessionList.GetUpperBound(1)
                    If SvSessionList(clClass - 1, i) Is Nothing Then
                        flg = False
                        Exit For
                    End If
                Next
            End SyncLock
            If flg Then ' 全グループのエントリーが完了
                Inform_Entry(clClass)
            End If
        Else
            ' 既に登録されている Entry Errorを送信する
            SvWriteLine("EERR" & Splitter & cmd(1) & Splitter & cmd(2))
        End If
    End Sub
    ' エントリー完了通知
    Sub Inform_Entry(ByVal ClassNo As Integer)
        ClassStatus(ClassNo - 1) = 1
        NoClass += 1
        MainForm.Invoke(New MsgDelegate(AddressOf MessageBox.Show), New Object() {MainForm, "クラス" & ClassNo & "のエントリーが完了しました。実験を開始するには実験開始ボタンをクリックしてください。", _
                "エントリー完了通知", MessageBoxButtons.OK, MessageBoxIcon.Information})
    End Sub
    ' "Step"コマンドの処理
    Private Sub Process_Step(ByVal cmd() As String)
        Dim i, ord(NoGroup - 1) As Integer
        Dim StepOnFlag As Boolean
        SyncLock StepData.SyncRoot
            ' 入力ステップをStepDataに登録
            StepData(clClass - 1, clGrpNo - 1, TrialCounter(clClass - 1), 0) = Integer.Parse(cmd(3))
            ' 全グループのStepデータが揃ったかチェック
            StepOnFlag = Check_StepData()
        End SyncLock
        If StepOnFlag Then
            ' 揃っていれば進度を計算
            Calc_Progress()
            ' 累積進度を計算
            Cum_Progress()
            ' 画面に表示，オペレータに通知 RaiseEvent
            Inform_Step(clClass)
            ' 試行回数のカウンターをカウントアップ
            TrialCounter(clClass - 1) += 1
            ' クライアントに通知
            Send_Progress(clClass, TrialCounter(clClass - 1) - 1)
            For i = 0 To PauseTime.GetUpperBound(0)
                If PauseTime(i) = TrialCounter(clClass - 1) Then
                    ' 試行回数が指定のものであれば，順位と累積進度を送信
                    Calc_Order(clClass, TrialCounter(clClass - 1) - 1, ord) ' 順位の計算
                    Send_ALLDATA(clClass, TrialCounter(clClass - 1) - 1, ord)   ' 順位と進度を送信
                    If i <> PauseTime.GetUpperBound(0) Then
                        ' オペレータにチャット開始の通知 RaiseEvent
                        MainForm.Invoke(New MsgDelegate(AddressOf MessageBox.Show), New Object() {MainForm, "クラス" & clClass & "の" & TrialCounter(clClass - 1) & _
                                        "試行目が終了しました。チャットを開始する場合はチャット開始ボタンを押してください", _
                                        "チャット開始通知", MessageBoxButtons.OK, MessageBoxIcon.Information})
                    End If
                    Exit For
                End If
            Next
        End If
    End Sub
    ' クライアントに進度を通知
    Private Sub Send_Progress(ByVal clno As Integer, ByVal tCount As Integer)
        Dim i As Integer
        Dim msgString As String

        For i = 0 To NoGroup - 1
            ' PRGRSSコマンドを生成
            msgString = "PRGRSS" & Splitter & StepData(clno - 1, i, tCount, 1)
            SyncLock SvSessionList.SyncRoot
                If SvSessionList(clno - 1, i) IsNot Nothing Then
                    SvSessionList(clno - 1, i).SvWriteLine(msgString)
                End If
            End SyncLock
        Next
    End Sub
    ' 順位と累積進度のデータを送信
    Private Sub Send_ALLDATA(ByVal clno As Integer, ByVal tno As Integer, ByRef ord() As Integer)
        Dim i As Integer
        Dim cmdString As String
        ' ALLDATAコマンドの生成
        cmdString = "ALLDATA"
        For i = 0 To NoGroup - 1
            cmdString &= Splitter & ord(i) & Splitter & StepData(clno - 1, i, tno, 2)
        Next
        ' 全グループへ送信
        Send_AllGroups(clno, cmdString)
    End Sub
    ' 順位計算用構造体
    Structure OderData
        Dim grpno As Integer
        Dim stp As Integer
    End Structure
    ' 順位計算
    Private Sub Calc_Order(ByVal clno As Integer, ByVal tno As Integer, ByRef ord() As Integer)
        Dim wrk(NoGroup - 1), t As OderData
        Dim i, j As Integer
        ' 累積進度データをワークに移す
        For i = 0 To NoGroup - 1
            wrk(i).grpno = i
            wrk(i).stp = StepData(clno - 1, i, tno, 2)
        Next
        ' wrkの並べ替え
        For i = 0 To NoGroup - 2
            For j = i To NoGroup - 1
                If wrk(i).stp < wrk(j).stp Then
                    t = wrk(i) : wrk(i) = wrk(j) : wrk(j) = t
                End If
            Next
        Next
        ' 順位データをセット
        ord(wrk(0).grpno) = 1
        For i = 1 To NoGroup - 1
            If wrk(i).stp = wrk(i - 1).stp Then
                ord(wrk(i).grpno) = ord(wrk(i - 1).grpno)
            Else
                ord(wrk(i).grpno) = i + 1
            End If
        Next
    End Sub
    ' 進度計算
    Private Sub Calc_Progress()
        Dim i, j As Integer
        ' 入力ステップが1の場合は進度を1にセット
        Set_Progress(1, 1)
        For i = 2 To MaxStep
            ' 入力ステップが2以上の場合は同じ入力ステップがいくつあるか数える
            ' その数によって進度を設定
            j = Count_Step(i)
            If j <= MaxStep + 1 - i And j <> 0 Then  ' 同じ入力ステップが少ないか等しい場合はその値
                Set_Progress(i, i)
            Else    ' 同じ入力ステップが多い場合は0
                Set_Progress(i, 0)
            End If
        Next
    End Sub
    ' 累積進度を計算
    Private Sub Cum_Progress()
        Dim i As Integer
        SyncLock StepData.SyncRoot
            For i = 0 To NoGroup - 1
                If TrialCounter(clClass - 1) = 0 Then
                    StepData(clClass - 1, i, TrialCounter(clClass - 1), 2) = _
                        StepData(clClass - 1, i, TrialCounter(clClass - 1), 1)
                Else
                    StepData(clClass - 1, i, TrialCounter(clClass - 1), 2) = _
                        StepData(clClass - 1, i, TrialCounter(clClass - 1), 1) + StepData(clClass - 1, i, TrialCounter(clClass - 1) - 1, 2)
                End If
            Next
        End SyncLock
    End Sub
    ' 進度をセット
    Private Sub Set_Progress(ByVal stp As Integer, ByVal SetVal As Integer)
        Dim i As Integer
        SyncLock StepData.SyncRoot
            For i = 0 To StepData.GetUpperBound(1)
                If StepData(clClass - 1, i, TrialCounter(clClass - 1), 0) = stp Then
                    StepData(clClass - 1, i, TrialCounter(clClass - 1), 1) = SetVal
                End If
            Next
        End SyncLock
    End Sub
    ' ステップ数のカウント
    Private Function Count_Step(ByVal stp As Integer) As Integer
        Dim i, j As Integer
        j = 0
        SyncLock StepData.SyncRoot
            For i = 0 To StepData.GetUpperBound(1)
                If StepData(clClass - 1, i, TrialCounter(clClass - 1), 0) = stp Then
                    j += 1
                End If
            Next
        End SyncLock
        Count_Step = j
    End Function
    ' クラス内の全グループのステップデータが揃っているかチェック
    Private Function Check_StepData() As Boolean
        Dim i, j As Integer
        Check_StepData = False
        j = 0
        SyncLock StepData.SyncRoot
            For i = 0 To StepData.GetUpperBound(1)
                If StepData(clClass - 1, i, TrialCounter(clClass - 1), 0) <> 0 Then
                    j = j + 1
                End If
            Next
        End SyncLock
        If j >= NoGroup Then
            Check_StepData = True
        End If
    End Function
    ' "MSG"コマンドの処理
    Private Sub Process_MSG(ByVal cmd() As String)
        ' チャットのメッセージを全グループに送信
        Send_AllGroups(clClass, "MSG" & Splitter & TrialCounter(clClass - 1) & _
                       Splitter & clClass & Splitter & clGroup & Splitter & cmd(4))
        ' メッセージをチャットログに保存
        Save_Log(clClass, cmd)
        ' オペレータのフォームに出力
        MainForm.Invoke(New RTBDelegate(AddressOf MainForm.Set_RTB), New Object() {clClass, clGroup, cmd(4)})
    End Sub
    ' ステップデータが揃った通知 イベントハンドラ
    Sub Inform_Step(ByVal ClassNo As Integer)
        Dim i As Integer
        For i = 0 To NoGroup - 1
            MainForm.Invoke(New iDGVDelegate(AddressOf MainForm.Set_iDGV), New Object() {ClassNo - 1, i, (TrialCounter(ClassNo - 1) + 1) * 3 - 2, StepData(ClassNo - 1, i, TrialCounter(ClassNo - 1), 0)})
            MainForm.Invoke(New iDGVDelegate(AddressOf MainForm.Set_iDGV), New Object() {ClassNo - 1, i, (TrialCounter(ClassNo - 1) + 1) * 3 - 1, StepData(ClassNo - 1, i, TrialCounter(ClassNo - 1), 1)})
            MainForm.Invoke(New iDGVDelegate(AddressOf MainForm.Set_iDGV), New Object() {ClassNo - 1, i, (TrialCounter(ClassNo - 1) + 1) * 3, StepData(ClassNo - 1, i, TrialCounter(ClassNo - 1), 2)})
        Next
        MainForm.Invoke(New MsgDelegate(AddressOf MessageBox.Show), New Object() {MainForm, "クラス" & ClassNo & "のステップデータが揃いました。", _
                "ステップ結果通知", MessageBoxButtons.OK, MessageBoxIcon.Information})
    End Sub
    ' メッセージをログに保存
    Private Sub Save_Log(ByVal clsno As Integer, ByRef cmd() As String)
        Dim msgString As String
        Const CSplitter As String = ","
        msgString = "第" & TrialCounter(clsno - 1) & "回試行" & CSplitter & _
            cmd(2) & CSplitter & cmd(3) & CSplitter & cmd(4)

        Select Case clsno
            Case 1
                ChatLog1.Add(msgString)
            Case 2
                ChatLog2.Add(msgString)
            Case 3
                ChatLog3.Add(msgString)
            Case 4
                ChatLog4.Add(msgString)
            Case 5
                ChatLog5.Add(msgString)
        End Select
    End Sub
    ' 送信処理用スレッド
    Sub SvSendThread()
        Try
            Do While ClWriteSignal.WaitOne() AndAlso ClWriteLoopFlag
                ' 送信Queueのデータ送信
                Do While ClWriteQueue.Count > 0
                    ClWriter.WriteLine(ClWriteQueue.Dequeue())
                Loop
            Loop
        Catch ex As Exception
            ' Error
            MainForm.Invoke(New MsgDelegate(AddressOf MessageBox.Show), New Object() {MainForm, ex.Message, "送信スレッドエラー", MessageBoxButtons.OK, MessageBoxIcon.Error})
            ' Close Socket
            ClSocket.Close()
        End Try
    End Sub
    ' 指定されたクラスの全グループにメッセージを送信
    Sub Send_AllGroups(ByVal clno As Integer, ByVal msgString As String)
        Dim i As Integer
        For i = 0 To NoGroup - 1
            SyncLock SvSessionList.SyncRoot
                If SvSessionList(clno - 1, i) IsNot Nothing Then
                    SvSessionList(clno - 1, i).SvWriteLine(msgString)
                End If
            End SyncLock
        Next
    End Sub
    ' 1行のメッセージを送信
    Sub SvWriteLine(ByVal sLine As String)
        ClWriteQueue.Enqueue(sLine)
        ClWriteSignal.Set()
        Log_SystemData("Send" & clClass & "-" & clGroup & ">" & sLine)
    End Sub
    ' Syslog Data 登録
    Sub Log_SystemData(ByVal s As String)
        Dim NowDate As Date = Date.Now
        SyncLock SysLog.SyncRoot
            SysLog.Add(String.Format("{0:00}:{1:00}:{2:00} ", _
                                     NowDate.Hour, NowDate.Minute, NowDate.Second) & " " & s)
        End SyncLock
    End Sub
End Class
